/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */


/**
 * Code source :
 * http://dmauro.github.io/Keypress/
 * 
 */



document.addEventListener("DOMContentLoaded", Main, false); // appel au chargement de la page



/**
 * Fonction principale
 * Appelée au chargement de la page
 * 
 */
function Main()
{
    console.log("Main");

    var oDivGame = document.getElementById("idGameDiv");

    var oListenKeys = new window.keypress.Listener();// écouteur du clavier


    // écoute une touche appuyée 
    oListenKeys.simple_combo("a", function()
    {
        oDivGame.innerHTML = "Vous avez appuyé la touche a.";
        console.log("Vous avez appuyé la touche a.");
    });


    // écoute un combo de plusieurs touches appuyées simultanément
    oListenKeys.simple_combo("ctrl s", function()
    {
        oDivGame.innerHTML = "Vous avez appuyé sur les touches ctrl et s.";
        console.log("Vous avez appuyé sur les touches ctrl et s.");
    });


    // possibilité de compter un combo sur des touches
    oListenKeys.counting_combo("w s", function(e, count)
    {
        oDivGame.innerHTML = "Vous avez appuyé sur les touches w et s " + count + " fois.";
        console.log("Vous avez appuyé sur les touches cmd et s " + count + " fois.");
    });


    // possibilité d'enregistrer une séquence de combos
    oListenKeys.sequence_combo("up down left right q s enter", function() 
    {
        oDivGame.innerHTML = "Combo réussi !!!";
        console.log("Combo réussi !!!");
    }, true);


    // fonctions avancées de gestion des touches du clavier
    var oScope = this;
    var oCombosList = oListenKeys.register_many([
        {
            "keys"          : "z",
            "is_exclusive"  : true,// appel uniquement cette séquence de touches et pas les autres (si elles sont définis)
            "on_keydown"    : function() // sur l'appui de la touche
            {
                oDivGame.innerHTML = "Vous avez appuyé la touche z.";
                console.log("Vous avez appuyé la touche z.");
            },

            "on_keyup"      : function(e) // sur le relachement de la touche
            {
                oDivGame.innerHTML = "Vous avez relaché la touche z.";
                console.log("Vous avez relaché la touche z.");
            },
            "on_release"        : null,// idem on_keyup
            "prevent_default"   : false,
            "prevent_repeat"    : false,// éviter les répétitions des touches
            "is_unordered"      : false,// true pour possibilité de presser le combo de touches dans le désordre
            "is_counting"       : false,// compte le nombre de fois appuyé sur les touches
            "is_solitary"       : false,// pour les séquences combo
            "is_sequence"       : false,// true pour créer une suite de touches, un combo
            "this"          : oScope
        },

        {
            "keys"          : "e",
            "is_exclusive"  : true,
            "on_keyup"      : function(event) 
            {
                oDivGame.innerHTML = "Vous avez relaché la touche e.";
                console.log("Vous avez relaché la touche e.");
            },
            "this"          : oScope
        },

        {
            "keys"          : "r t y",
            "is_exclusive"  : true,
            "is_sequence"   : true,
            "on_keydown"    : function() 
            {
                oDivGame.innerHTML = "Vous avez appuyé sur les touches r t y.";
                console.log("Vous avez appuyé sur les touches r t y");
            },

            "on_keyup"      : function(e) 
            {
                oDivGame.innerHTML = "Vous avez relaché les touches r t y.";
                console.log("Vous avez relaché les touches r t ya.");
            },
            "this"          : oScope
        }
    ]);


    // pour supprimer un écouteur particulier du clavier
    // oListenKeys.unregister_combo("w s");
    // oListenKeys.unregister_combo(oCombosList);

    // pour supprimer tous les écouteurs du clavier
    // oListenKeys.reset();

}





